Deprecation of the IPv6 Router Alert Option for New Protocols
RFC 9805
Ron Bonica
Juniper Networks
2025-06
INT
6man
IPv6
This document deprecates the IPv6 Router Alert option. Protocols that use the IPv6 Router Alert option may continue to do so, even in future versions. However, new protocols that are standardized in the future must not use the IPv6 Router Alert option.
This document updates RFC 2711.
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc9805.
Copyright Notice
Copyright (c) 2025 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Revised BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Revised BSD License.
Table of Contents
- 1. Introduction
- 2. Requirements Language
- 3. Issues Associated with the IPv6 Router Alert Option
- 4. Deprecation of the IPv6 Router Alert Option
- 5. Future Work
- 6. Security Considerations
- 7. IANA Considerations
- 8. References
  - 8.1. Normative References
  - 8.2. Informative References
- Appendix A. Protocols That Use the IPv6 Router Alert Option
- Acknowledgements
- Author's Address
Introduction
In IPv6 [RFC8200], optional internet-layer information is encoded in separate headers that may be placed between the IPv6 header and the upper-layer header in a packet. There is a small number of such extension headers, each one identified by a distinct Next Header value.
One of these extension headers is called the Hop-by-Hop Options header. The Hop-by-Hop Options header is used to carry optional information that may be examined and processed by every node along a packet's delivery path.
The Hop-by-Hop Options header can carry one or more options. Among these is the IPv6 Router Alert option [RFC2711].
The IPv6 Router Alert option provides a mechanism whereby routers can know when to intercept datagrams not addressed to them without having to extensively examine every datagram. The semantic of the IPv6 Router Alert option is that "routers should examine this datagram more closely". Excluding this option tells the router that there is no need to examine this datagram more closely.
As explained below, the IPv6 Router Alert option introduces many issues.
This document updates [RFC2711]. Implementers of protocols that continue to use the IPv6 Router Alert option can continue to reference [RFC2711] for IPv6 Router Alert option details.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Issues Associated with the IPv6 Router Alert Option
[RFC6398] identifies security considerations associated with the IPv6 Router Alert option. In a nutshell, the IP Router Alert Option does not provide a universal mechanism to accurately and reliably distinguish between IP Router Alert packets of interest and unwanted IP Router Alerts. This creates a security concern because, short of appropriate router-implementation-specific mechanisms, the router's control plane is at risk of being flooded by unwanted traffic.
NOTE: Many routers maintain separation between forwarding and control plane hardware. The forwarding plane is implemented on high-performance Application-Specific Integrated Circuits (ASICs) and Network Processors (NPs), while the control plane is implemented on general-purpose processors. Given this difference, the control plane is more susceptible to a Denial-of-Service (DoS) attack than the forwarding plane.
[RFC6192] demonstrates how a network operator can deploy Access Control Lists (ACLs) that protect the control plane from DoS attacks. These ACLs are effective and efficient when they select packets based upon information that can be found in a fixed position. However, they become less effective and less efficient when they must parse a Hop-by-Hop Options header, searching for the IPv6 Router Alert option.
Network operators can address the security considerations raised in [RFC6398] by:
- Deploying the operationally complex and computationally expensive ACLs described in [RFC6192].
- Configuring their routers to ignore the IPv6 Router Alert option.
- Dropping or severely rate limiting packets that contain the Hop-by-Hop Options header at the network edge.
These options become less viable as protocol designers continue to design protocols that use the IPv6 Router Alert option.
[RFC9673] seeks to eliminate hop-by-hop processing on the control plane. However, because of its unique function, the IPv6 Router Alert option is granted an exception to this rule. One approach would be to deprecate the IPv6 Router Alert option, because current usage beyond the local network appears to be limited and packets containing Hop-by-Hop options are frequently dropped. Deprecation would allow current implementations to continue using it, but its use could be phased out over time.
Deprecation of the IPv6 Router Alert Option
This document deprecates the IPv6 Router Alert option. Protocols that use the IPv6 Router Alert option MAY continue to do so, even in future versions. However, new protocols that are standardized in the future MUST NOT use the IPv6 Router Alert option. Appendix A contains an exhaustive list of protocols that MAY continue to use the IPv6 Router Alert option.
This document updates [RFC2711].
Future Work
A number of protocols use the IPv6 Router Alert option; these are listed in Appendix A. The only protocols in Appendix A that have widespread deployment are Multicast Listener Discovery Version 2 (MLDv2) [RFC9777] and Multicast Router Discovery (MRD) [RFC4286]. The other protocols either have limited deployment, are experimental, or have no known implementation.
It is left for future work to develop new versions of MLDv2 and MRD that do not rely on the IPv6 Router Alert option. That task is out of scope for this document.
Security Considerations
This document mitigates all security considerations associated with the IPv6 Router Alert option. These security considerations can be found in [RFC2711], [RFC6192], and [RFC6398].
IANA Considerations
IANA has marked the IPv6 Router Alert option as "DEPRECATED for New Protocols" in the "Destination Options and Hop-by-Hop Options" registry and added this document as a reference.
IANA has also made a note in the "IPv6 Router Alert Option Values" registry stating that the registry is closed for allocations and added a reference to this document. The experimental codepoints in this registry have been changed to "Reserved" (i.e., they are no longer available for experimentation).
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC2711]

IPv6 Router Alert Option
C. Partridge
A. Jackson
October 1999
RFC 2711
DOI 10.17487/RFC2711
[RFC6398]

IP Router Alert Considerations and Usage
F. Le Faucheur, Ed.
October 2011
BCP 168
RFC 6398
DOI 10.17487/RFC6398
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8200]

Internet Protocol, Version 6 (IPv6) Specification
S. Deering
R. Hinden
July 2017
STD 86
RFC 8200
DOI 10.17487/RFC8200
[RFC9673]

IPv6 Hop-by-Hop Options Processing Procedures
R. Hinden
G. Fairhurst
October 2024
RFC 9673
DOI 10.17487/RFC9673
Informative References
[RFC1633]

Integrated Services in the Internet Architecture: an Overview
R. Braden
D. Clark
S. Shenker
June 1994
RFC 1633
DOI 10.17487/RFC1633
[RFC3031]

Multiprotocol Label Switching Architecture
E. Rosen
A. Viswanathan
R. Callon
January 2001
RFC 3031
DOI 10.17487/RFC3031
[RFC3175]

Aggregation of RSVP for IPv4 and IPv6 Reservations
F. Baker
C. Iturralde
F. Le Faucheur
B. Davie
September 2001
RFC 3175
DOI 10.17487/RFC3175
[RFC3208]

PGM Reliable Transport Protocol Specification
T. Speakman
J. Crowcroft
J. Gemmell
D. Farinacci
S. Lin
D. Leshchiner
M. Luby
T. Montgomery
L. Rizzo
A. Tweedly
N. Bhaskar
R. Edmonstone
R. Sumanasekera
L. Vicisano
December 2001
RFC 3208
DOI 10.17487/RFC3208
[RFC4080]

Next Steps in Signaling (NSIS): Framework
R. Hancock
G. Karagiannis
J. Loughney
S. Van den Bosch
June 2005
RFC 4080
DOI 10.17487/RFC4080
[RFC4286]

Multicast Router Discovery
B. Haberman
J. Martin
December 2005
RFC 4286
DOI 10.17487/RFC4286
[RFC5946]

Resource Reservation Protocol (RSVP) Extensions for Path-Triggered RSVP Receiver Proxy
F. Le Faucheur
J. Manner
A. Narayanan
A. Guillou
H. Malik
October 2010
RFC 5946
DOI 10.17487/RFC5946
[RFC5971]

GIST: General Internet Signalling Transport
H. Schulzrinne
R. Hancock
October 2010
RFC 5971
DOI 10.17487/RFC5971
[RFC5979]

NSIS Operation over IP Tunnels
C. Shen
H. Schulzrinne
S. Lee
J. Bang
March 2011
RFC 5979
DOI 10.17487/RFC5979
[RFC6016]

Support for the Resource Reservation Protocol (RSVP) in Layer 3 VPNs
B. Davie
F. Le Faucheur
A. Narayanan
October 2010
RFC 6016
DOI 10.17487/RFC6016
[RFC6192]

Protecting the Router Control Plane
D. Dugal
C. Pignataro
R. Dunn
March 2011
RFC 6192
DOI 10.17487/RFC6192
[RFC6401]

RSVP Extensions for Admission Priority
F. Le Faucheur
J. Polk
K. Carlberg
October 2011
RFC 6401
DOI 10.17487/RFC6401
[RFC7506]

IPv6 Router Alert Option for MPLS Operations, Administration, and Maintenance (OAM)
K. Raza
N. Akiya
C. Pignataro
April 2015
RFC 7506
DOI 10.17487/RFC7506
[RFC8029]

Detecting Multiprotocol Label Switched (MPLS) Data-Plane Failures
K. Kompella
G. Swallow
C. Pignataro, Ed.
N. Kumar
S. Aldrin
M. Chen
March 2017
RFC 8029
DOI 10.17487/RFC8029
[RFC9570]

Deprecating the Use of Router Alert in LSP Ping
K. Kompella
R. Bonica
G. Mirsky, Ed.
May 2024
RFC 9570
DOI 10.17487/RFC9570
[RFC9777]

Multicast Listener Discovery Version 2 (MLDv2) for IPv6
B. Haberman, Ed.
March 2025
STD 101
RFC 9777
DOI 10.17487/RFC9777
Protocols That Use the IPv6 Router Alert Option
Table 1 contains an exhaustive list of protocols that use the IPv6 Router Alert option. There are no known IPv6 implementations of MPLS Ping. Neither Integrated Services (Intserv) nor Next Steps in Signaling (NSIS) are widely deployed. All NSIS protocols are experimental. Pragmatic Generic Multicast (PGM) is experimental, and there are no known IPv6 implementations.
Protocols That Use the IPv6 Router Alert Option
Protocol | References | Application
Multicast Listener Discovery Version 2 (MLDv2) | [RFC9777] | IPv6 Multicast
Multicast Router Discovery (MRD) | [RFC4286] | IPv6 Multicast
Pragmatic General Multicast (PGM) | [RFC3208] | IPv6 Multicast
MPLS Ping (Use of the IPv6 Router Alert option is deprecated) | [RFC7506] [RFC8029] [RFC9570] | MPLS Operations, Administration, and Maintenance (OAM)
Resource Reservation Protocol (RSVP): Both IPv4 and IPv6 implementations | [RFC3175] [RFC5946] [RFC6016] [RFC6401] | Integrated Services (Intserv) [RFC1633] and Multiprotocol Label Switching (MPLS) [RFC3031]
Next Steps in Signaling (NSIS) | [RFC5979] [RFC5971] | NSIS [RFC4080]
Acknowledgements
Thanks to Zafar Ali, Brian Carpenter, Toerless Eckert, David Farmer, Adrian Farrel, Bob Hinden, and Jen Linkova for their reviews of this document.
Author's Address
Ron Bonica
Juniper Networks
United States of America
rbonica@juniper.net